//Margin
float constHoriMarg=120;
float constVertMarg=80;

int rows=70, columns=132;

//2D matrix 
Table table1, table2, table3, table4;
float[][] dataMatrix1;
float[][] dataMatrix2;
float[][] dataMatrix3;
float[][] dataMatrix4;
float maxValue, minValue;
int numRows1, numRows2, numRows3, numRows4;
int numColumns1, numColumns2, numColumns3, numColumns4;

//width and height for cell
float cellWidth, cellHeight;

//year
int startYear=2006;

boolean colorApplied=false;
boolean labelApplied=false;
boolean rectOne=false;
boolean rectTwo=false;
boolean rectThree=false;
boolean rectFour=false;

void setup() {
  size(1270, 720);
  //fullScreen();

  //Put data into Processing table from csv
  table1 =loadTable("acbk.csv", "header");
  table2=loadTable("acdvd.csv", "header");
  table3=loadTable("acvhs.csv", "header");
  table4=loadTable("accdrom.csv", "header");
  numRows1 = table1.getRowCount();
  numRows2 = table2.getRowCount();
  numRows3 = table3.getRowCount();
  numRows4 = table4.getRowCount();
  numColumns1 = table1.getColumnCount();
  numColumns2 = table2.getColumnCount();
  numColumns3 = table3.getColumnCount();
  numColumns4 = table4.getColumnCount();
  dataMatrix1=new float[numRows1][numColumns1-2];
  dataMatrix2=new float[numRows2][numColumns2-2];
  dataMatrix3=new float[numRows3][numColumns3-2];
  dataMatrix4=new float[numRows4][numColumns4-2];
  //println("Rows:"+numRows1+"Columns:"+numColumns1);

  //set the background Matrix
  for (int i=0; i<numRows1; i++) {
    for (int j=0; j<numColumns1-2; j++) {
      dataMatrix1[i][j] = table1.getFloat(i, j+2);
      //println(dataMatrix1[i][j]);
    }
  }

  for (int i=0; i<numRows2; i++) {
    for (int j=0; j<numColumns2-2; j++) {
      dataMatrix2[i][j] = table2.getFloat(i, j+2);
      //println(dataMatrix2[i][j]);
    }
  }

  for (int i=0; i<numRows3; i++) {
    for (int j=0; j<numColumns3-2; j++) {
      dataMatrix3[i][j] = table3.getFloat(i, j+2);
      //println(dataMatrix3[i][j]);
    }
  }

  for (int i=0; i<numRows4; i++) {
    for (int j=0; j<numColumns4-2; j++) {
      dataMatrix4[i][j] = table4.getFloat(i, j+2);
      //println(dataMatrix4[i][j]);
    }
  }
}

void draw() {
  background(#C5734F);

  cellWidth = (width - constHoriMarg*2)/columns;
  cellHeight = (height - constVertMarg*4)/rows;

  //Draw second layer background
  stroke(#1f6088);
  strokeWeight(3);
  fill(#C59C44);
  rect(constHoriMarg, constVertMarg+50, cellWidth*columns, cellHeight*(rows-8));

  //Draw Year
  for (int i=0; i<12; i+=3) {
    textAlign(CENTER, CENTER);
    textSize(18);
    fill(#e9f0f4);
    text(startYear+i, constHoriMarg+(12+(12*i))*cellWidth, 
      constVertMarg+35);
  }

  //Draw Title
  textAlign(LEFT, CENTER);
  textSize(26);
  fill(#e9f0f4);
  text("CHANGE IN MEDIA TYPE POPULARITY OVER TIME", constHoriMarg, 
    constVertMarg-40);
  fill(#81e298);
  textSize(14);
  fill(#e9f0f4);
  text("From Seattle Public Library", constHoriMarg, constVertMarg-60);
  text("The Trend of Checkout Numbers of Books By Media Type",
  constHoriMarg, constVertMarg-15);

  if (labelApplied==true)labelAppeared();
  if (colorApplied==true)colorAppeared();
}
